System.Gadget.onSettingsClosing = SettingsClosing;

function validateNumber(e){
 var numcheck = /\d/;
 return numcheck.test(String.fromCharCode(e.keyCode));
}

function sizechange(){
 var tmp = parseInt(size.value,10);
 if (isNaN(tmp)) size.value = Math.ceil(System.Gadget.Settings.read("SetSize") * 100);
}

function timechange(){
 var tmp = parseInt(timetoalert.value,10);
 if (isNaN(tmp)) timetoalert.value = Math.ceil(System.Gadget.Settings.read("refresherrtime") / 1000);
}

function timetoforciblychange(){
 var tmp = parseInt(timetoforciblycheck.value,10);
 if (isNaN(tmp) || tmp <= 0) timetoforciblycheck.value = Math.ceil(System.Gadget.Settings.read("ForciblyCheckTime") / 60000);
}

String.prototype.removeallblanks=function(){
 // remove all blanks from string
 var res=/\s+/g;
 return this.replace(res,'');
}

function hidesize(){
 sizehide.disabled = autoscaleDPI.checked;
}

function forciblytimehide(){
 hideforcibly.disabled = !enableforcibly.checked;
}

function selectfile(){
 if (!playsound.checked) return;
 var strInitialDirectory = System.Environment.getEnvironmentVariable("USERPROFILE") + "\\Music\\"
 var strFilter = "Audio File (*.wav):*.wav::";
 var file_location = System.Shell.chooseFile(true, strFilter, strInitialDirectory, ""); //true for open
 if (file_location) document.getElementById("soundpath").value = file_location.path;
}

function selecconnectiontfile(){
 if (!playconnectionsound.checked) return;
 var strInitialDirectory = System.Environment.getEnvironmentVariable("USERPROFILE") + "\\Music\\"
 var strFilter = "Audio File (*.wav):*.wav::";
 var file_location = System.Shell.chooseFile(true, strFilter, strInitialDirectory, ""); //true for open
 if (file_location) document.getElementById("soundconnectionpath").value = file_location.path;
}

function testsound1(){
 if (playsound.checked) System.Sound.playSound(document.getElementById("soundpath").value);
}

function testsound2(){
 if (playconnectionsound.checked) System.Sound.playSound(document.getElementById("soundconnectionpath").value);
}

function hideselectbutton(){
 if (playsound.checked){
  document.getElementById("soundhide").disabled = false;
  document.getElementById("soundpath").disabled = false;
 }
 else{
  document.getElementById("soundhide").disabled = true;
  document.getElementById("soundpath").disabled = true;
 }
}

function hideconnectselectbutton(){
 if (playconnectionsound.checked){
  document.getElementById("soundconnectionhide").disabled = false;
  document.getElementById("soundconnectionpath").disabled = false;
  document.getElementById("hidefirstplaystring").disabled = false;
 }
 else{
  document.getElementById("soundconnectionhide").disabled = true;
  document.getElementById("soundconnectionpath").disabled = true;
  document.getElementById("hidefirstplaystring").disabled = true;
 }
}

function selectrunofffile(){
 var strInitialDirectory = System.Environment.getEnvironmentVariable("USERPROFILE");
 var strFilter = "Batch File (*.cmd *.bat):*.cmd;*.bat:Executable File (*.exe):*.exe:Command File (*.com):*.com::";
 var file_location = System.Shell.chooseFile(true, strFilter, strInitialDirectory, ""); //true for open
 if (file_location) document.getElementById("runoffpath").value = file_location.path;
}

function selectrunonfile(){
 var strInitialDirectory = System.Environment.getEnvironmentVariable("USERPROFILE");
 var strFilter = "Batch File (*.cmd *.bat):*.cmd;*.bat:Executable File (*.exe):*.exe:Command File (*.com):*.com::";
 var file_location = System.Shell.chooseFile(true, strFilter, strInitialDirectory, ""); //true for open
 if (file_location) document.getElementById("runonpath").value = file_location.path;
}

function onLoad(){
 siteurl.value = System.Gadget.Settings.read("GetURL");
 size.value = Math.ceil(System.Gadget.Settings.read("SetSize") * 100);
 timetoalert.value = Math.ceil(System.Gadget.Settings.read("refresherrtime") / 1000);

 runonpath.value = System.Gadget.Settings.read("ProgramON");
 runoffpath.value = System.Gadget.Settings.read("ProgramOFF");
 var tmp = System.Gadget.Settings.read("RunWhenStart");
 if (tmp == "false") firstrunexec.checked = false;
 else firstrunexec.checked = true;

 tmp = System.Gadget.Settings.read("PlaySound");
 if (tmp == "false") playsound.checked = false;
 else playsound.checked = true;
 hideselectbutton();
 soundpath.value = System.Gadget.Settings.read("AlarmSound");

 tmp = System.Gadget.Settings.read("PlayConnectionSound");
 if (tmp == "false") playconnectionsound.checked = false;
 else playconnectionsound.checked = true;
 hideconnectselectbutton();
 soundconnectionpath.value = System.Gadget.Settings.read("ConnectionSound");
 tmp = System.Gadget.Settings.read("PlayWhenStart");
 if (tmp == "false") firstrunplay.checked = false;
 else firstrunplay.checked = true;

 tmp = System.Gadget.Settings.read("EnableForciblyCheck");
 if (tmp == "false") enableforcibly.checked = false;
 else enableforcibly.checked = true;
 forciblytimehide();
 timetoforciblycheck.value = Math.ceil(System.Gadget.Settings.read("ForciblyCheckTime") / 60000);

 tmp = System.Gadget.Settings.read("DPIautoscale");
 if (tmp == "false") autoscaleDPI.checked = false;
 else autoscaleDPI.checked = true;
 hidesize();
}

function SettingsClosing(event){
 if (event.closeAction == event.Action.commit){
  System.Gadget.Settings.write("GetURL", siteurl.value);
  sizechange();
  System.Gadget.Settings.write("SetSize", size.value / 100);
  timechange();
  System.Gadget.Settings.write("refresherrtime", timetoalert.value * 1000);

  System.Gadget.Settings.write("ProgramON", runonpath.value);
  System.Gadget.Settings.write("ProgramOFF", runoffpath.value);
  if (firstrunexec.checked) System.Gadget.Settings.write ("RunWhenStart", "true");
  else System.Gadget.Settings.write ("RunWhenStart", "false");

  if (playsound.checked) System.Gadget.Settings.write ("PlaySound", "true");
  else System.Gadget.Settings.write ("PlaySound", "false");
  System.Gadget.Settings.write("AlarmSound", soundpath.value);

  if (playconnectionsound.checked) System.Gadget.Settings.write ("PlayConnectionSound", "true");
  else System.Gadget.Settings.write ("PlayConnectionSound", "false");
  System.Gadget.Settings.write("ConnectionSound", soundconnectionpath.value);
  if (firstrunplay.checked) System.Gadget.Settings.write ("PlayWhenStart", "true");
  else System.Gadget.Settings.write ("PlayWhenStart", "false");

  if (enableforcibly.checked) System.Gadget.Settings.write ("EnableForciblyCheck", "true");
  else System.Gadget.Settings.write ("EnableForciblyCheck", "false");
  timetoforciblychange();
  System.Gadget.Settings.write("ForciblyCheckTime", timetoforciblycheck.value * 60000);

  if (autoscaleDPI.checked) System.Gadget.Settings.write ("DPIautoscale", "true");
  else System.Gadget.Settings.write ("DPIautoscale", "false");

  savesettingstofile();
 }
 event.cancel = false;
}

function savesettingstofile(){
 var fs = new ActiveXObject("Scripting.FileSystemObject");
 var inifilename = System.Environment.getEnvironmentVariable("APPDATA") + "\\" + System.Gadget.name + "_Settings.ini";
 try {
  var inifile = fs.OpenTextFile(inifilename, 2, true); //2 write file true - create file

  try {
   inifile.WriteLine(";Connection Watcher (c) 2012-2015 by Igor 'Igogo' Bushin");  
   inifile.WriteLine(";meow meow purr");

   inifile.WriteLine(siteurl.value);
   inifile.WriteLine(size.value / 100);
   inifile.WriteLine(timetoalert.value * 1000);

   if (playsound.checked) inifile.WriteLine("true");
   else inifile.WriteLine("false");
   inifile.WriteLine(soundpath.value);
   if (playconnectionsound.checked) inifile.WriteLine("true");
   else inifile.WriteLine("false");
   inifile.WriteLine(soundconnectionpath.value);
   if (firstrunplay.checked) inifile.WriteLine("true");
   else inifile.WriteLine("false");

   if (autoscaleDPI.checked) inifile.WriteLine("true");
   else inifile.WriteLine("false");

   if (enableforcibly.checked) inifile.WriteLine("true");
   else inifile.WriteLine("false");
   inifile.WriteLine(timetoforciblycheck.value * 60000);

   inifile.WriteLine(runonpath.value);
   inifile.WriteLine(runoffpath.value);
   if (firstrunexec.checked) inifile.WriteLine("true");
   else inifile.WriteLine("false");
  }//end try 2

  finally {inifile.Close()}
 }//end try 1

 catch (e) {}
}
function showtab(id){
 names = new Array ("tabname_1","tabname_2","tabname_3","tabname_4","tabname_5");
 conts= new Array ("tabcontent_1","tabcontent_2","tabcontent_3","tabcontent_4","tabcontent_5");
 for(i=0;i<names.length;i++) { document.getElementById(names[i]).className = 'nonactive' }
 for(i=0;i<conts.length;i++) { document.getElementById(conts[i]).className = 'hide' }
 document.getElementById('tabname_' + id).className = 'active';
 document.getElementById('tabcontent_' + id).className = 'show';
}

function restoreprograms(){
 runoffpath.value = "none";
 runonpath.value = "none";
}

function restoresettingstodefault(){
 siteurl.value = "http://www.google.com";
 size.value = 100;
 autoscaleDPI.checked = true;
 timetoalert.value = 1;
 restoreprograms();
 firstrunexec.checked = false;
 playsound.checked = false;
 hideselectbutton();
 playsound.checked = true;
 hideselectbutton();
 soundpath.value = "media/redalert.wav";
 playconnectionsound.checked = true;
 hideconnectselectbutton();
 soundconnectionpath.value = "media/connectionon.wav";
 firstrunplay.checked = true;
 enableforcibly.checked = false;
 forciblytimehide();
 timetoforciblycheck.value = 5;
}